#include <acknex.h>
#include <default.c>

int i = 0;
int j = 0;
int k = 0;

VECTOR* c_current		= {x=-777;y=-777;z=-777;}
VECTOR* c_red			= {x=0;y=0;z=255;}
VECTOR* c_green		= {x=0;y=255;z=0;}
VECTOR* c_blue			= {x=255;y=0;z=0;}
VECTOR* c_lightblue	= {x=255;y=64;z=64;}
VECTOR* c_yellow		= {x=0;y=255;z=255;}
VECTOR* c_purple		= {x=255;y=0;z=255;}
VECTOR* c_white		= {x=255;y=255;z=255;}

STRING* tempstr = "meow";

#define current -777

#define cw 1
#define ccw -1

#define type_pan 1
#define type_tilt 2
#define type_roll 3

#define off 0
#define on 1
#define over 2

#define new(type) malloc(sizeof(type##))

int int_random(int _from,int _to){return(integer(random(_to+1-_from)+_from));}

typedef struct xfont
{
	STRING* name;
	BMAP* map;
	int width;
	int height;
	BMAP* lettermaps[256];
	int left_edge[256];
	int right_edge[256];
	int letter_width[256];
	int letter_height[256];
	int next_letter_offset[256];
	int border_space;
	var format;
} xfont;

typedef struct xletter
{
	int id;
	int num;
	int line;
	PANEL* lpan;

	var offset;
	var b_sx;
	var b_sy;
	var t_sx;
	var t_sy;
	var inv_state;

	var b_x;
	var b_y;
	var t_x;
	var t_y;

	var b_alpha;
	var t_alpha;

	var b_angle;
	var t_angle;

	var time_total_alpha;
	var time_passed_alpha;

	var time_total_xy;
	var time_passed_xy;

	var time_total_size;
	var time_passed_size;

	var time_total_angle;
	var time_passed_angle;

	int change_pos;
	int change_size;
	int change_alpha;
	int change_angle;

	int r_edge;
	int l_edge;
	int width;
	int height;

	int flash;
} xletter;

typedef struct xtext
{
	int id; 
	int pos_x;
	int pos_y;
	int active_changes;
	int letters;
	int size;
	int change_pos;
	int change_size;
	int change_alpha;
	int change_angle;
	int tags;

	int width;
	int height;
	int lines;

	xfont* font;
	PANEL* textpan;
	STRING* text;
	xletter* letter[1000];

} xtext;

xfont* arial_map_font;
xtext* myxtext;
xtext* xtext_array[100];

void xtext_manager();
int xtext_num = 0;
int xtm_active = 0;

PANEL* pan_create2(char* _content, int _layer, STRING* _bitmap, int _pos_x, int _pos_y, long _flags)
{
	str_cpy(tempstr,"");
	if(_bitmap != 0)
	{
		str_cat(tempstr,"bmap=");
		str_cat(tempstr,_bitmap);
		str_cat(tempstr,";");
	}

	str_cat(tempstr,_content);

	PANEL* _pan = pan_create(tempstr,_layer);
	
	_pan.pos_x = _pos_x;
	_pan.pos_y = _pos_y;

	_pan.flags |= (_flags);
	return(_pan);
}
void stop_all_text_mods()
{
	if(xtm_active == 1){xtm_active = 2;}
}

void reset_text(xtext* _xtext,var _pos_x,var _pos_y,var _alpha)
{
	_xtext.active_changes = 0;
	_xtext.change_pos = 0;
	_xtext.change_size = 0;
	_xtext.change_alpha = 0;
	_xtext.change_angle = 0;

	if(_pos_x != current){_xtext.pos_x = _pos_x;}
	if(_pos_y != current){_xtext.pos_y = _pos_y;}
	xletter* xl;
	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		if(_alpha != current){xl.lpan.alpha = _alpha;}
		set(xl.lpan,VISIBLE);
		xl.lpan.scale_x = 1;
		xl.lpan.scale_y = 1;
		xl.lpan.angle = 0;

		xl.b_sx = 0;
		xl.b_sy = 0;
		xl.t_sx = 0;
		xl.t_sy = 0;
		xl.inv_state = 0;

		xl.flash = 0; 

		xl.b_x = 0;
		xl.b_y = 0;
		xl.t_x = 0;
		xl.t_y = 0;

		xl.b_alpha = 0;
		xl.t_alpha = 0;

		xl.b_angle = 0;
		xl.t_angle = 0;

		xl.time_total_alpha = 0;
		xl.time_passed_alpha = 0;

		xl.time_total_xy = 0;
		xl.time_passed_xy = 0;

		xl.time_total_size = 0;
		xl.time_passed_size = 0;

		xl.time_total_angle = 0;
		xl.time_passed_angle = 0;

		xl.change_pos = 0;
		xl.change_size = 0;
		xl.change_alpha = 0;
		xl.change_angle = 0;
		
	}
}

void xtext_spread_from_center(xtext* _xtext,var _time,int _mode)
{
	int i,x,y,bx,by,line=0,wave=0,screen_offset_x=0,screen_offset_y=0,corner;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,100);
	_xtext.change_pos = 1;

	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}

		xl.change_pos = 1;
		xl.time_passed_xy = 0;
		
		corner = int_random(0,4);
		if(corner == 0){screen_offset_x = -50;screen_offset_y = int_random(-200,screen_size.y + 200);}
		if(corner == 1){screen_offset_x = int_random(-200,screen_size.x + 200);screen_offset_y = -50;}

		if(corner == 2){screen_offset_x = int_random(-200,screen_size.x + 200);screen_offset_y = screen_size.y + 50;}
		if(corner == 3){screen_offset_x = screen_size.x+50;screen_offset_y = int_random(-200,screen_size.y + 200);}

		
		if(_mode == 1)
		{ 
			xl.b_x = screen_offset_x;
			xl.b_y = screen_offset_y;
		}
		else
		{
			xl.b_x = xl.lpan.pos_x;
			xl.b_y = xl.lpan.pos_y;
		}

		if(_mode == 1)
		{
			xl.t_x = _xtext.pos_x + xl.offset * xl.lpan.scale_x;
			xl.t_y = _xtext.pos_y + _xtext.font.height * xl.line * xl.lpan.scale_y;
		}
		else
		{
			xl.t_x = screen_offset_x;
			xl.t_y = screen_offset_y;
		}

		xl.time_total_xy = _time * 16; 
	}

	_xtext.active_changes = 1;
	xtext_manager();
}


void xtext_spread_from_corner(xtext* _xtext,var _corner,var _time,var _wave_delay,int _mode)
{
	int i,x,y,bx,by,line=0,wave=0,screen_offset_x=0,screen_offset_y=0;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,100);
	_xtext.change_pos = 1;

	if(_corner == 0){screen_offset_x = 0;screen_offset_y = 0;}
	if(_corner == 1){screen_offset_x = screen_size.x;screen_offset_y = 0;}

	if(_corner == 2){screen_offset_x = 0;screen_offset_y = screen_size.y;}
	if(_corner == 3){screen_offset_x = screen_size.x;screen_offset_y = screen_size.y;}

	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		wave = integer(random(10));
		xl.change_pos = 1;
		
		delay = -_wave_delay * wave;
		xl.time_passed_xy = delay;

		
		if(_mode == 1)
		{
			xl.b_x = screen_offset_x;
			xl.b_y = screen_offset_y;
			xl.t_x = xl.lpan.pos_x;
			xl.t_y = xl.lpan.pos_y;
		}
		else
		{
			xl.b_x = xl.lpan.pos_x;
			xl.b_y = xl.lpan.pos_y;
			xl.t_x = screen_offset_x;
			xl.t_y = screen_offset_y;
		}
		
		xl.lpan.pos_x = xl.b_x;
		xl.lpan.pos_y = xl.b_y;
		
		xl.time_total_xy = _time * 16;
	}

	_xtext.active_changes = 1;
	xtext_manager();
}


void xtext_move_and_fade_waves(xtext* _xtext,var _b_x,var _b_y,var _t_x,var _t_y,var _time,var _letter_delay,var _wave_delay,var _offset_x,var _offset_y,var _alpha_b,var _alpha_t,var _alpha_time,var _flash)
{
	int i,alpha_b,alpha_t,x,y,bx,by,line=0,wave=0,screen_offset_x=0,screen_offset_y=0;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,_alpha_b);
	_xtext.change_pos = 1;
	_xtext.change_alpha = 1;

	if(_offset_x == -1){screen_offset_x = -_xtext.pos_x -_xtext.width;}
	if(_offset_x == 1){screen_offset_x = screen_size.x + _xtext.pos_x;}

	if(_offset_y == -1){screen_offset_y = -_xtext.pos_y -_xtext.height;}
	if(_offset_y == 1){screen_offset_y = screen_size.y + _xtext.pos_y;}

	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		wave = integer(random(10));
		xl.change_pos = 1;
		xl.change_alpha = 1;
		xl.flash = _flash;
		
		delay = -_wave_delay * wave;
		xl.time_passed_xy = delay;
		xl.time_passed_alpha = delay;
	
		if(_b_x == current){x=xl.lpan.pos_x;}
		else{x=_b_x;}
		if(_b_y == current){y=xl.lpan.pos_y;}
		else{y=_b_y;}

		
		xl.b_x = screen_offset_x + x;
		xl.b_y = screen_offset_y + y;

		if(_t_x == current){x=xl.lpan.pos_x;}
		else{x=_t_x;}
		if(_t_y == current){y=xl.lpan.pos_y;}
		else{y=_t_y;}

		xl.t_x = xl.offset * xl.lpan.scale_x + x;
		xl.t_y = _xtext.font.height * xl.line * xl.lpan.scale_y + y;
		xl.time_total_xy = _time * 16;

		
		if(_alpha_b == current){xl.b_alpha=xl.lpan.alpha;}
		else{xl.b_alpha=_alpha_b;}

		if(_alpha_t == current){xl.t_alpha=xl.lpan.alpha;}
		else{xl.t_alpha=_alpha_t;}

		xl.time_total_alpha = _alpha_time * 16;
	}

	_xtext.active_changes = 1;
	xtext_manager();
}

void xtext_rotate_to(xtext* _xtext,var _angle_b,var _angle_t,var _time,var _letter_delay,var _line_delay)
{
	int i,angle_b,angle_t,line=0;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,100);
	_xtext.change_angle = 1;
	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		xl.change_angle = 1;
		if(xl.line > line)
		{
			line++;
			delay = -_line_delay * line;
		}

		
		delay -= _letter_delay * _time;

		xl.time_passed_angle = delay;

		
		if(_angle_b == current){xl.b_angle=xl.lpan.angle;}
		else{xl.b_angle=_angle_b;}

		

		if(_angle_t == current){xl.t_angle=xl.lpan.angle;}
		else{xl.t_angle=_angle_t;}


		xl.time_total_angle = _time * 16;
	}

	_xtext.active_changes = 1;
	xtext_manager();
}



void xtext_fade_to(xtext* _xtext,var _alpha_b,var _alpha_t,var _time,var _letter_delay,var _line_delay,var _flash)
{
	int i,alpha_b,alpha_t,line=0;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,_alpha_b);
	_xtext.change_alpha = 1;
	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		xl.change_alpha = 1;
		xl.flash = _flash;
		if(xl.line > line)
		{
			line++;
			delay = -_line_delay * line;
		}

		
		delay -= _letter_delay * _time;
		xl.time_passed_alpha = delay;

		
		if(_alpha_b == current){xl.b_alpha=xl.lpan.alpha;}
		else{xl.b_alpha=_alpha_b;}

		

		if(_alpha_t == current){xl.t_alpha=xl.lpan.alpha;}
		else{xl.t_alpha=_alpha_t;}

		
		
		xl.time_total_alpha = _time * 16;
	}

	_xtext.active_changes = 1;
	xtext_manager();
}


void xtext_move_to(xtext* _xtext,var _pos_x,var _pos_y,var _time,var _letter_delay,var _line_delay)
{
	int i,x,y,line=0;
	var delay = 0;
	xletter* xl;
	reset_text(_xtext,current,current,100);
	_xtext.change_pos = 1;
	_xtext.pos_x = _pos_x;
	_xtext.pos_y = _pos_y;

	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		xl.change_pos = 1;
		if(xl.line > line)
		{
			line++;
			delay = -_line_delay * line;
		}

		
		delay -= _letter_delay * _time;

		xl.time_passed_xy = delay;

		
		xl.b_x = xl.lpan.pos_x;
		xl.b_y = xl.lpan.pos_y;

		if(_pos_x == current){x=xl.lpan.pos_x;}
		else{x=_pos_x;}
		if(_pos_y == current){y=xl.lpan.pos_y;}
		else{y=_pos_y;}

		
		xl.t_x = xl.offset * xl.lpan.scale_x + x;
		xl.t_y = _xtext.font.height * xl.line * xl.lpan.scale_y + y;
		xl.time_total_xy = _time * 16;
	}

	_xtext.active_changes = 1;
	xtext_manager();
}



void xtext_scale_to(xtext* _xtext,var _b_size_x,var _b_size_y,var _t_size_x,var _t_size_y,var _time,var _letter_delay,var _line_delay)
{
	int i,line=0;
	xletter* xl;
	reset_text(_xtext,current,current,100);
	_xtext.change_size = 1;
	_xtext.change_pos = 1;
	var delay=0,sx,sy;
	for(i = 0;i < _xtext.letters;i++)
	{
		xl = _xtext.letter[i];
		if(xl.id == 999 || xl.id == 888){continue;}
		xl.change_size = 1;
		if(xl.line > line)
		{
			line++;
			delay = -_line_delay * line;
		}

		
		delay -= _letter_delay * _time;
		xl.time_passed_size = delay;

		
		if(_b_size_x == current){xl.b_sx=xl.lpan.scale_x;}
		else{xl.b_sx=_b_size_x;}
		if(_b_size_y == current){xl.b_sy=xl.lpan.scale_y;}
		else{xl.b_sy=_b_size_y;}

		if(_t_size_x == current){xl.t_sx=xl.lpan.scale_x;}
		else{xl.t_sx=_t_size_x;}
		if(_t_size_y == current){xl.t_sy=xl.lpan.scale_y;}
		else{xl.t_sy=_t_size_y;}

		xl.inv_state = 0;

		if(xl.b_sx < 0.011 || xl.b_sy < 0.011){xl.inv_state = -1;}
		if(xl.t_sx < 0.011 || xl.t_sy < 0.011){xl.inv_state = 1;}
		
		if(xl.inv_state < 0){reset(xl.lpan,VISIBLE);}

		if(xl.lpan.bmap != 0)
		{
			if(bmap_width(xl.lpan.bmap)*abs(xl.b_sx) < 1){xl.b_sx = 0.1 * sign(xl.b_sx);}
			if(bmap_width(xl.lpan.bmap)*abs(xl.t_sx) < 1){xl.t_sx = 0.1 * sign(xl.t_sx);}
		}

		if(xl.lpan.bmap != 0)
		{
			if(bmap_width(xl.lpan.bmap)*abs(xl.b_sy) < 1){xl.b_sy = 0.1 * sign(xl.b_sy);}
			if(bmap_width(xl.lpan.bmap)*abs(xl.t_sy) < 1){xl.t_sy = 0.1 * sign(xl.t_sy);}
		}

		xl.lpan.scale_x = xl.b_sx;
		xl.lpan.scale_y = xl.b_sy;

		xl.time_total_size = _time * 16; 

		
			xl.change_pos = 1;

			xl.time_passed_xy = xl.time_passed_size;
		
			xl.b_x = xl.lpan.pos_x;
			xl.b_y = xl.lpan.pos_y;

			xl.t_x = _xtext.pos_x + xl.offset * xl.t_sx;
			xl.t_y = _xtext.pos_y - (_xtext.font.height * xl.t_sy) * 0.5 + _xtext.font.height * xl.line * xl.t_sy;
		
			xl.time_total_xy = _time * 16; 
	}

	_xtext.active_changes = 1;
	xtext_manager();
}
void flash(int _id,PANEL* _pan);

void xtext_manager()
{
	int i,j;
	if(xtm_active == 1){return;}
	xtm_active = 1;
	xletter* xl;
	int texts_active = 0;
	int letters_active = 0;
	int letters_changed_pos = 0;
	int letters_changed_size = 0;
	int letters_changed_alpha = 0;
	int letters_changed_angle = 0;
	while(1)
	{
		for(i=0;i<xtext_num;i++)
		{
			texts_active = 0;
			if(xtext_array[i] != 0)
			{
				if(xtm_active == 2){reset_text(xtext_array[i],current,current,100);}
				if(xtext_array[i].active_changes > 0)
				{
					texts_active = 1;
					letters_active = 0;
					for(j = 0;j < xtext_array[i].letters;j++)
					{
						xl = xtext_array[i].letter[j];
						if(xl.id == 999 || xl.id == 888){continue;}
						if(xl.change_pos == 1)
						{
							letters_active = 1;
							xl.time_passed_xy += time_step;
							if(xl.time_passed_xy >=  xl.time_total_xy)
							{
								xl.time_passed_xy = xl.time_total_xy;
								if(xl.time_passed_xy == 0)
								{
									xl.time_passed_xy = 1;
									xl.time_total_xy = 1;
								}
							}

							if(xl.time_passed_xy >= 0)
							{
								if(xl.lpan.pos_x != xl.t_x){xl.lpan.pos_x = xl.b_x + (xl.t_x - xl.b_x) * xl.time_passed_xy / xl.time_total_xy;}
								if(xl.lpan.pos_y != xl.t_y){xl.lpan.pos_y = xl.b_y + (xl.t_y - xl.b_y) * xl.time_passed_xy / xl.time_total_xy;}
							}

							if(xl.time_passed_xy == xl.time_total_xy)
							{
								xl.change_pos = 0;
								letters_changed_pos++;
								if(letters_changed_pos == xtext_array[i].letters-xtext_array[i].tags)
								{
									xtext_array[i].change_pos = 0;
								}
							}
						}

						if(xl.change_alpha == 1)
						{
							letters_active = 1;
							xl.time_passed_alpha += time_step;
							if(xl.time_passed_alpha >=  xl.time_total_alpha)
							{
								xl.time_passed_alpha = xl.time_total_alpha;
								if(xl.time_passed_alpha == 0)
								{
									xl.time_passed_alpha = 1;
									xl.time_total_alpha = 1;
								}
							}
							
							if(xl.time_passed_alpha >= 0)
							{
								if(xl.flash == 1)
								{
										flash(0,xl.lpan);
									xl.flash = 2;
								}
								
								if(xl.lpan.alpha != xl.t_alpha){xl.lpan.alpha = xl.b_alpha + (xl.t_alpha - xl.b_alpha) * xl.time_passed_alpha / xl.time_total_alpha;}
							}

							if(xl.time_passed_alpha == xl.time_total_alpha)
							{
								xl.change_alpha = 0;
								letters_changed_alpha++;
								if(letters_changed_alpha == xtext_array[i].letters-xtext_array[i].tags)
								{
									xtext_array[i].change_alpha = 0;
								}
							}
						}

						if(xl.change_angle == 1)
						{
							letters_active = 1;
							xl.time_passed_angle += time_step;
							if(xl.time_passed_angle >=  xl.time_total_angle)
							{
								xl.time_passed_angle = xl.time_total_angle;
								if(xl.time_passed_angle == 0)
								{
									xl.time_passed_angle = 1;
									xl.time_total_angle = 1;
								}
							}
							
							if(xl.time_passed_angle >= 0)
							{
								if(xl.lpan.angle != xl.t_angle){xl.lpan.angle = xl.b_angle + (xl.t_angle - xl.b_angle) * xl.time_passed_angle / xl.time_total_angle;}
							}

							if(xl.time_passed_angle == xl.time_total_angle)
							{
								xl.change_angle = 0;
								letters_changed_angle++;
								if(letters_changed_angle == xtext_array[i].letters-xtext_array[i].tags)
								{
									xtext_array[i].change_angle = 0;
								}
							}
						}

						if(xl.change_size == 1)
						{
							letters_active = 1;
							xl.time_passed_size += time_step;
							if(xl.time_passed_size >=  xl.time_total_size)
							{
								xl.time_passed_size = xl.time_total_size;
								if(xl.time_passed_size == 0)
								{
									xl.time_passed_size = 1;
									xl.time_total_size = 1;
								}
							}
							
							if(xl.time_passed_size >= 0)
							{
								if(xl.inv_state == -1){set(xl.lpan,VISIBLE);xl.inv_state = 0;}
								if(xl.lpan.scale_x != xl.t_sx){xl.lpan.scale_x = xl.b_sx + (xl.t_sx - xl.b_sx) * xl.time_passed_size / xl.time_total_size;}
								if(xl.lpan.scale_y != xl.t_sy){xl.lpan.scale_y = xl.b_sy + (xl.t_sy - xl.b_sy) * xl.time_passed_size / xl.time_total_size;}
							}

							if(xl.time_passed_size == xl.time_total_size)
							{
								if(xl.inv_state == 1)
								{
									reset(xl.lpan,VISIBLE);
								}

								xl.change_size = 0;
								letters_changed_size++;
								if(letters_changed_size == xtext_array[i].letters-xtext_array[i].tags)
								{
									xtext_array[i].change_size = 0;
								}
							}
						}
					}

					if(letters_active == 0){xtext_array[i].active_changes = 0;}
				}
			}	

			if(texts_active == 0){xtm_active = 2;}
		}

		if(xtm_active == 2){xtm_active = 0;break;}
		wait(1);
	}
}
void xeffect(int _id)
{
	var move_speed = 0;
	var fade_speed = 0;
	var scale_speed = 0;
	var rotate_speed = 0;

	var letter_delay = 0;
	var wave_delay = 0;
	var line_delay = 0;

	var screen_offsetx = 0;
	var screen_offsety = 0;

	var s_x = 0;
	var s_y = 0;

	switch(_id)
	{
		case 0:
			move_speed = 0.5;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.5;
			xtext_move_to(myxtext,100,100,0,0,0);
			xtext_move_and_fade_waves(myxtext,current,current,100,200,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,0,100,fade_speed,0);
		break;

		case 1:
			move_speed = 0.3;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.3;
			xtext_move_to(myxtext,100,200,0,0,0);
			xtext_move_and_fade_waves(myxtext,current,current,100,300,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,100,0,fade_speed,0);
		break;

		case 2:
			move_speed = 0.3;
			wave_delay = 3;
			screen_offsetx = 0;
			xtext_move_to(myxtext,100,200,0,0,0);
			xtext_spread_from_corner(myxtext,screen_offsetx,move_speed,wave_delay,1);
		break;

		case 3:
			move_speed = 0.3;
			wave_delay = 3;
			screen_offsetx = 1;
			xtext_move_to(myxtext,100,200,0,0,0);
			xtext_spread_from_corner(myxtext,screen_offsetx,move_speed,wave_delay,0);
		break;

		case 4:
			move_speed = 0.5;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.5;
			xtext_move_to(myxtext,-100,100,0,0,0);
			xtext_move_and_fade_waves(myxtext,-100,100,200,100,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,0,100,fade_speed,0);
		break;

		case 5:
			move_speed = 0.5;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.5;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_move_and_fade_waves(myxtext,200,100,500,100,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,100,0,fade_speed,0);
		break;

		case 6:
			letter_delay = 1;
			line_delay = 3;
			fade_speed = 0.5;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_fade_to(myxtext,0,100,fade_speed,letter_delay,line_delay,0);
		break;

		case 7:
			letter_delay = 1;
			line_delay = 3;
			fade_speed = 0.5;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_fade_to(myxtext,100,0,fade_speed,letter_delay,line_delay,0);
		break;

		case 8:
			letter_delay = 0;
			line_delay = 7;
			fade_speed = 0.5;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_fade_to(myxtext,0,100,fade_speed,letter_delay,line_delay,0);
		break;

		case 9:
			letter_delay = 0;
			line_delay = 7;
			fade_speed = 0.5;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_fade_to(myxtext,100,0,fade_speed,letter_delay,line_delay,0);
		break;

		case 10:
			scale_speed = 0.6;
			letter_delay = 1;
			line_delay = 3;
			s_x = 1;
			s_y = 1;
			
			xtext_scale_to(myxtext,1,1,0.01,0.01,0,0,0);
			xtext_scale_to(myxtext,current,current,s_x,s_y,scale_speed,letter_delay,line_delay);
		break;

		case 11:
			scale_speed = 0.3;
			letter_delay = 0.3;
			line_delay = 3;
			s_x = 1;
			s_y = 1;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,0.01,0.01,s_x,s_y,scale_speed,letter_delay,line_delay);
		break;

		case 12:
			scale_speed = 0.6;
			letter_delay = 1;
			line_delay = 3;
			
			xtext_scale_to(myxtext,0.01,1,1,1,scale_speed,letter_delay,line_delay);
		break;

		case 13:
			scale_speed = 0.3;
			letter_delay = 0.3;
			line_delay = 3;
			
			xtext_scale_to(myxtext,1,1,0.01,1,scale_speed,letter_delay,line_delay);
		break;

		case 14:
			scale_speed = 0.5;
			letter_delay = 1;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,-1,-1,1,1,scale_speed,letter_delay,line_delay);
		break;

		case 15:
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,-1,1,1,1,scale_speed,letter_delay,line_delay);
		break;

		case 16:
			scale_speed = 0.5;
			letter_delay = 1;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,1,1,-1,-1,scale_speed,letter_delay,line_delay);
		break;

		case 17:
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,1,1,-1,1,scale_speed,letter_delay,line_delay);
		break;

		case 18:
			scale_speed = 0.5;
			letter_delay = 1;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,1,1,-1,0.01,scale_speed,letter_delay,line_delay);
		break;

		case 19:
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,1,1,0.01,-1,scale_speed,letter_delay,line_delay);
			while(myxtext.active_changes == 1){wait(1);}
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_scale_to(myxtext,-1,-0.5,1,1,scale_speed,letter_delay,line_delay);
		break;

		case 20:
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_move_to(myxtext,200,100,0,0,0);
			xtext_scale_to(myxtext,1,1,-1,-1,scale_speed,letter_delay,line_delay);
			while(myxtext.active_changes == 1){wait(1);}
			scale_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_scale_to(myxtext,-1,-1,1,1,scale_speed,letter_delay,line_delay);
		break;

		case 21:
			move_speed = 0.3;
			xtext_spread_from_center(myxtext,move_speed,0);

		break;

		case 22:
			move_speed = 0.3;
			xtext_spread_from_center(myxtext,move_speed,1);
		break;

		case 23:
			rotate_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_rotate_to(myxtext,0,360,rotate_speed,letter_delay,line_delay);
		break;

		case 24:
			rotate_speed = 1;
			letter_delay = 2;
			line_delay = 1;
			xtext_rotate_to(myxtext,0,360,rotate_speed,letter_delay,line_delay);
		break;

		case 25:
			rotate_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 1;
			xtext_rotate_to(myxtext,0,360,rotate_speed,letter_delay,line_delay);
		break;

		case 26:
			rotate_speed = 1;
			letter_delay = 0;
			line_delay = 0;
			xtext_rotate_to(myxtext,0,360,rotate_speed,letter_delay,line_delay);
		break;

		case 27:
			rotate_speed = 0.5;
			letter_delay = 0.5;
			line_delay = 3;
			xtext_rotate_to(myxtext,0,720,rotate_speed,letter_delay,line_delay);
		break;

		case 28:
			rotate_speed = 1;
			letter_delay = 0;
			line_delay = 0;
			xtext_rotate_to(myxtext,0,720,rotate_speed,letter_delay,line_delay);
		break;

		case 29:
			letter_delay = 1;
			line_delay = 3;
			fade_speed = 0.7;
			xtext_fade_to(myxtext,0,100,fade_speed,letter_delay,line_delay,1);
		break;

		case 30:
			letter_delay = 1;
			line_delay = 3;
			fade_speed = 0;
			xtext_fade_to(myxtext,100,0,fade_speed,letter_delay,line_delay,1);
		break;

		case 31:
			move_speed = 0.3;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.4;
			xtext_move_to(myxtext,200,200,0,0,0);
			xtext_move_and_fade_waves(myxtext,current,current,200,200,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,0,100,fade_speed,1);
		break;

		case 32:
			move_speed = 0.3;
			letter_delay = 1;
			wave_delay = 2;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0;
			xtext_move_to(myxtext,200,200,0,0,0);
			xtext_move_and_fade_waves(myxtext,current,current,200,200,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,100,0,fade_speed,1);
		break;
	
		case 33:
			move_speed = 0.5;
			letter_delay = 1;
			wave_delay = 3;
			screen_offsetx = 0;
			screen_offsety = 0;
			fade_speed = 0.5;
			xtext_move_to(myxtext,100,100,0,0,0);
			xtext_move_and_fade_waves(myxtext,current,current,100,200,move_speed,letter_delay,wave_delay,screen_offsetx,screen_offsety,0,100,fade_speed,1);
		break;

		case 34:
			letter_delay = 0.5;
			line_delay = 0;
			fade_speed = 0.2;
			xtext_fade_to(myxtext,100,0,fade_speed,letter_delay,line_delay,1);
		break;
	}
}
void flash(int _id,PANEL* _pan)
{
	var i;
	
	PANEL* letter_flash = pan_create2("",_pan.layer + 1,"map_star.tga",_pan.pos_x,_pan.pos_y,VISIBLE);

	var fsizex = bmap_width(_pan.bmap);
	var fsizey = bmap_height(_pan.bmap);

	var base_scale_x = 100/bmap_width(letter_flash.bmap) * 0.01;
	var base_scale_y = 100/bmap_height(letter_flash.bmap) * 0.01;

	letter_flash.scale_x = base_scale_x;
	letter_flash.scale_y = base_scale_y;
	
	var target_scale_x = fsizex * 1.2 * base_scale_x;
	var target_scale_y = fsizey * 1.2 * base_scale_y;

	var time_passed = 0;
	var time_passed_total = 2;

	var base_x = letter_flash.pos_x+fsizey*0.6;
	var base_y = letter_flash.pos_y+fsizey*0.6;

	var target_x = letter_flash.pos_x - bmap_width(letter_flash.bmap)*target_scale_x * 0.5+fsizey*0.6;
	var target_y = letter_flash.pos_y - bmap_height(letter_flash.bmap)*target_scale_y * 0.5+fsizey*0.6;

	var pass = 0;
	while(1)
	{
		time_passed += time_step;
		letter_flash.pos_x = base_x + (target_x - base_x) * time_passed / time_passed_total;
		letter_flash.pos_y = base_y + (target_y - base_y) * time_passed / time_passed_total;
		letter_flash.scale_x = base_scale_x + (target_scale_x - base_scale_x) * time_passed / time_passed_total;
		letter_flash.scale_y = base_scale_y + (target_scale_y - base_scale_y) * time_passed / time_passed_total;

		if(time_passed >=  time_passed_total)
		{
			if(pass == 1){break;}
			pass = 1;
			time_passed = 0;
			
			target_x = base_x;
			base_x = letter_flash.pos_x;
			
			target_y = base_y;
			base_y = letter_flash.pos_y;
			
			target_scale_x = base_scale_x;
			base_scale_x = letter_flash.scale_x;
			
			target_scale_y = base_scale_y;
			base_scale_y = letter_flash.scale_y;
		}
		wait(1);
	}

	pan_remove(letter_flash);
}

void set_vars()
{
	video_set(1024,768,0,1);
	vec_set(sky_color,vector(10,10,10));
	mouse_sync = 0;
	mouse_calm = 10;
 	mouse_time = 16;
	mouse_mode = 4;
	mouse_pointer = 1;
	preload_mode = 3;
	d3d_entsort = 1;
	randomize();
}

VECTOR color_vec;

xtext* create_text_panels(STRING* _tempstr,int _pos_x,int _pos_y,xfont* _font,int _bmap_mode,var _size,int _align)
{
	xtext* _xtext;
	xletter* xl;
	_xtext = new(xtext);
	xtext_array[xtext_num] =_xtext;
	_xtext.letters = str_len(_tempstr);
	_xtext.tags = 0;
	STRING* tempstr = "";
	int offset = 0,line = 0,ix,iy,letters_in_line=0,i;
	var pixel;

	_xtext.pos_x = _pos_x;
	_xtext.pos_y = _pos_y;
	_xtext.width = 0;
	_xtext.height = _font.height;
	_xtext.font = _font;
	_xtext.text = str_create("#512");

	_xtext.change_pos = 0;
	_xtext.change_size = 0;
	_xtext.change_alpha = 0;

	str_cpy(_xtext.text,_tempstr);
	_xtext.size = _size;
	var color_mode = 0;
	var p_alpha = 0;
	var target_align = 0;
	var align_offset = 0;
	var line_len[100];

	for(i=0;i<_xtext.letters;i++)
	{
		

		_xtext.letter[i] = new(xletter);
		_xtext.letter[i].offset = 0;

		_xtext.letter[i].b_sx = 0;
		_xtext.letter[i].b_sy = 0;

		_xtext.letter[i].t_sx = 0;
		_xtext.letter[i].t_sy = 0;

		_xtext.letter[i].b_x = 0;
		_xtext.letter[i].b_y = 0;
		_xtext.letter[i].t_x = 0;
		_xtext.letter[i].t_y = 0;

		_xtext.letter[i].b_alpha = 0;
		_xtext.letter[i].t_alpha = 0;

		_xtext.letter[i].time_total_alpha = 0;
		_xtext.letter[i].time_passed_alpha = 0;

		_xtext.letter[i].time_total_xy = 0;
		_xtext.letter[i].time_passed_xy = 0;

		_xtext.letter[i].time_total_size = 0;
		_xtext.letter[i].time_passed_size = 0;

		_xtext.letter[i].change_pos = 0;
		_xtext.letter[i].change_size = 0;
		_xtext.letter[i].change_alpha = 0;

		str_cpy(tempstr,_xtext.text);
		str_clip(tempstr,i);
		str_trunc(tempstr,_xtext.letters-1-i);

		if(color_mode == 1)
		{
			if(str_cmp(tempstr,"r"))
			{
				color_mode = 2;
			}
			if(str_cmp(tempstr,"g"))
			{
				color_mode = 3;
			}
			if(str_cmp(tempstr,"b"))
			{
				color_mode = 4;
			}

			_xtext.letter[i].id = 888;
			_xtext.tags++;
			continue;
		}

		
		if(str_cmp(tempstr,"#"))
		{
			_xtext.letter[i].id = 999;
			line++;
			offset = 0;
			letters_in_line = 0;
			_xtext.height += _font.height;
			_xtext.tags++;
			continue;
		}

		if(str_cmp(tempstr,"^"))
		{
			_xtext.letter[i].id = 888;
			if(color_mode == 0){color_mode = 1;}
			else{color_mode = 0;}
			_xtext.tags++;
			continue;
		}

		_xtext.letter[i].id = str_to_asc(tempstr);
		_xtext.letter[i].line = line;

		offset -= _font.left_edge[_xtext.letter[i].id] * _xtext.size;
		_xtext.letter[i].offset = offset;
		_xtext.letter[i].lpan = pan_create2("",10,0,_pos_x + offset, _pos_y + _xtext.height * _xtext.size -_font.height * _xtext.size,VISIBLE);
		_xtext.letter[i].lpan.scale_x = _xtext.size;
		_xtext.letter[i].lpan.scale_y = _xtext.size;

		if(color_mode > 1)
		{
			set(_xtext.letter[i].lpan,LIGHT);
			if(color_mode == 2)
			{
				vec_set(_xtext.letter[i].lpan.blue,c_red);
			}

			if(color_mode == 3)
			{
				vec_set(_xtext.letter[i].lpan.blue,c_green);
			}

			if(color_mode == 4)
			{
				vec_set(_xtext.letter[i].lpan.blue,c_blue);
			}
		}


		letters_in_line++;

		
		offset += _font.next_letter_offset[_xtext.letter[i].id] * _xtext.size;
		line_len[line] = offset;
		_xtext.letter[i].lpan.bmap = _font.lettermaps[_xtext.letter[i].id];
		_xtext.letter[i].width = _font.letter_width[_xtext.letter[i].id];
		_xtext.letter[i].height = _font.letter_height[_xtext.letter[i].id];
		if(_xtext.width < offset){_xtext.width = offset;}
	
		
	}

	
	_xtext.textpan = pan_create2("",11,0,_pos_x,_pos_y,VISIBLE);
	_xtext.textpan.bmap = bmap_createblack(_xtext.width, _xtext.height, _font.format);

	bmap_preload(_xtext.textpan.bmap);
	bmap_lock(_xtext.textpan.bmap,0);

	if(_align < _xtext.width)
	{
		target_align = _xtext.width;
	}
	else
	{
		target_align = _align;
	}
	offset = _pos_x;
	var offset_y = _pos_y;
	line = 0;
	for(i=0;i<_xtext.letters;i++)
	{

		if(_xtext.letter[i].id == 888)
		{
			continue;
		}

		if(_xtext.letter[i].id == 999)
		{
			offset = _pos_x;
			offset_y += _font.height;
			line++;
			continue;
		}

		if(line_len[line] < target_align)
		{
			align_offset = (target_align - line_len[line]);
			if(_align == 0){align_offset*=0.5;}
			if(_align == -1){align_offset=0;}
			_xtext.letter[i].lpan.pos_x += align_offset;
		}
		else
		{
			align_offset = 0;
		}

		bmap_lock(_xtext.letter[i].lpan.bmap,0);
		for(ix = _font.left_edge[_xtext.letter[i].id];ix < _font.right_edge[_xtext.letter[i].id];ix++)
		{
			for(iy = 0;iy < _font.height;iy++)
			{
				pixel = pixel_for_bmap(_xtext.letter[i].lpan.bmap, ix, iy);
				if(_xtext.letter[i].lpan.flags & LIGHT)
				{
					pixel_to_vec(color_vec.x,p_alpha,_font.format,pixel);

					color_vec.x = _xtext.letter[i].lpan.blue;
					color_vec.y = _xtext.letter[i].lpan.green;
					color_vec.z = _xtext.letter[i].lpan.red;

					pixel = pixel_for_vec(color_vec,p_alpha,_font.format);
				}
				pixel_to_bmap(_xtext.textpan.bmap,align_offset + ix+(offset - _pos_x) - _font.left_edge[_xtext.letter[i].id],iy+(offset_y - _pos_y), pixel);
			}
		}

		offset += _font.letter_width[_xtext.letter[i].id] + _font.border_space;
		bmap_unlock(_xtext.letter[i].lpan.bmap);
	}

	_xtext.textpan.scale_x = _xtext.size;
	_xtext.textpan.scale_y = _xtext.size;
	bmap_unlock(_xtext.textpan.bmap);

	xtext_num++;
	return(_xtext);
}

void get_letter_size(xfont* _font,int _id)
{
	if(_id == 32)
	{
		_font.left_edge[_id] = _font.width*0.30;
		_font.right_edge[_id] = _font.width*0.70;
		_font.letter_width[_id] = _font.width*0.4;
		_font.letter_height[_id] = _font.height*0.6;
		_font.next_letter_offset[_id] = _font.left_edge[_id] + _font.letter_width[_id] + _font.border_space;
		return;
	}

	VECTOR tempvec;
	var w_line,h_line,width,height,pixel,alphavar,left_edge = -1,right_edge = -1,bmap_format;

	bmap_format = bmap_lock(_font.lettermaps[_id],0);
	width = bmap_width(_font.lettermaps[_id]);
	height = bmap_height(_font.lettermaps[_id]);

	for(w_line=1;w_line<width;w_line++)
	{
		for(h_line=0;h_line<height;h_line++)
		{
			pixel = pixel_for_bmap(_font.lettermaps[_id],w_line,h_line);
			pixel_to_vec(tempvec,alphavar,bmap_format,pixel);

			if(alphavar != 0)
			{
				if(left_edge == -1)
				{
					left_edge = w_line;
					break;
				}
			}
		}

		if(left_edge != -1){break;}
	}

	_font.left_edge[_id] = left_edge;
	for(w_line=width;w_line>1;w_line--)
	{
		for(h_line=0;h_line<height;h_line++)
		{
			pixel = pixel_for_bmap(_font.lettermaps[_id],w_line,h_line);
			pixel_to_vec(tempvec,alphavar,bmap_format,pixel);

			if(alphavar != 0)
			{
				if(right_edge == -1)
				{
					right_edge = w_line;
					break;
				}
			}
		}
		if(right_edge != -1){break;}
	}

	_font.right_edge[_id] = right_edge;
	_font.letter_width[_id] = right_edge - left_edge;
	_font.next_letter_offset[_id] = _font.left_edge[_id] + _font.letter_width[_id] + _font.border_space;
	_font.letter_height[_id] = _font.height*0.6;

	bmap_unlock(_font.lettermaps[_id]);
}

xfont* create_xfont(STRING* _font_bmap_name,int _font_id,int _space_between_letters)
{
	int i;
	xfont* _font;
	_font = new(xfont);

	_font.name = str_create("#512");
	str_cpy(_font.name,_font_bmap_name);

	_font.map = bmap_create(_font.name);
	bmap_preload(_font.map);

	var line,column,pixel,global_pixel_x,global_pixel_y,pix_passed_x,pix_passed_y,letter_id,letter_width,letter_height;
	_font.border_space = _space_between_letters;
	_font.width = bmap_width(_font.map) / 32;
	_font.height = bmap_height(_font.map) / 8;
	_font.format = bmap_lock(_font.map, 0);

	for(line=0;line < 8;line++)
	{
		for(column=0;column < 32;column++)
		{
			letter_id = column + (line*32);
			_font.lettermaps[letter_id] = bmap_createblack(_font.width, _font.height, _font.format);
			bmap_preload(_font.lettermaps[letter_id]);
			bmap_lock(_font.lettermaps[letter_id],0);
			global_pixel_x = _font.width * column;
			for(pix_passed_x=0;pix_passed_x<_font.width;pix_passed_x++,global_pixel_x++)
			{
				global_pixel_y = _font.height * line;	
				for(pix_passed_y=0;pix_passed_y < _font.height;pix_passed_y++,global_pixel_y++)
				{
					pixel = pixel_for_bmap(_font.map, global_pixel_x, global_pixel_y);
					pixel_to_bmap(_font.lettermaps[letter_id], pix_passed_x, pix_passed_y, pixel);
				}
			}

			bmap_unlock(_font.lettermaps[letter_id]);
			get_letter_size(_font,letter_id);
			
		}
	}

	bmap_unlock(_font.map);
	bmap_purge(_font.map);

	return(_font);
}


var get_l_width(xfont* _font,STRING* _letter)
{
	return(_font.letter_width[str_to_asc(_letter)]);
}

void main()
{
	level_load(0);
	set_vars();
	wait(10);
	
	int i;

	for(i=0;i<100;i++){xtext_array[i]=0;}

	arial_map_font = create_xfont("djz_font.tga",0,3);

	myxtext = create_text_panels("many different ^rcool^ text effects can be created#if you convert ^bletters ^ to ^bpanels ^ #you can ^r paint them^, align, scale, rotate, fade separately.#also you can define distance between letters #and all this with ^gany^ bitmap font! #try and replace this font with yours and look for yourself =)",110,480,arial_map_font,1,1,-1);

	var delay = 0;

	gotoloop:
	wait(-2);
	
	xeffect(0);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(1);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(2);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(3);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(4);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(5);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(6);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(7);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(8);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(9);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(10);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(11);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(12);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(13);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(14);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(15);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(16);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(17);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(18);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(19);while(myxtext.active_changes > 0){wait(1);}while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(20);while(myxtext.active_changes > 0){wait(1);}while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(21);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(22);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(23);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(24);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(25);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(26);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(27);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(28);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(29);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(30);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(31);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(32);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(33);while(myxtext.active_changes > 0){wait(1);}wait(100);
	xeffect(34);while(myxtext.active_changes > 0){wait(1);}wait(100);

	goto gotoloop;
}
